#ifndef CLASSES_H
#define CLASSES_H
//---------------------------------------------------------------------------
#include <string>
#include <windows.h>
//---------------------------------------------------------------------------
//Class definitions
enum Target{tConsole,tWindows,tDll,tLib};
class MakeFileOptions
{
	private:
		HWND owner_;
		Target target_;
		bool threaded_;
		bool debug_;
		std::string cppfiles_;
		std::string libfiles_;
		std::string rcfiles_;
		std::string objfiles_;
		std::string deffiles_;
		std::string ReplaceExt(const std::string& filename,const std::string& ext);
	public:
		MakeFileOptions(HWND owner);
		bool Threaded()const{return threaded_;}
		bool Debug()const{return debug_;}
		Target GetTarget()const{return target_;}
		std::string GetCppFiles()const{return cppfiles_;}
		std::string GetLibFiles()const{return libfiles_;}
		std::string GetRCFiles()const{return rcfiles_;}		
		std::string GetObjFiles()const{return objfiles_;}
		std::string GetDefFiles()const{return deffiles_;}
};

class MakeFileGenerator
{
	private:
		std::string makefilename_;
		std::string GetPath(const std::string& filename);
		bool SaveMakefile(const std::string& str);
		std::string ChangeExt(std::string str,const std::string ext);
	public:
		MakeFileGenerator(const std::string &makefilename):makefilename_(makefilename){}
		bool GenerateConsoleMakeFile(const std::string &cppfiles,
		                             const std::string &libfiles,
				                         const std::string &rcfiles,
				                         const std::string &objfiles,
				                         const std::string &deffiles,
				                         bool threaded,
				                         bool debug);
		bool GenerateWindowsMakeFile(const std::string &cppfiles,
		                             const std::string &libfiles,
				                         const std::string &rcfiles,
				                         const std::string &objfiles,
				                         const std::string &deffiles,
				                         bool threaded,
				                         bool debug);
		bool GenerateDllMakeFile(const std::string &cppfiles,
		                         const std::string &libfiles,
				                     const std::string &rcfiles,
				                     const std::string &objfiles,
				                     const std::string &deffiles,
				                     bool threaded,
				                     bool debug);
		bool GenerateLibMakeFile(const std::string &cppfiles,
		                         const std::string &libfiles,
				                     const std::string &rcfiles,
				                     const std::string &objfiles,
				                     const std::string &deffiles,
				                     bool threaded,
				                     bool debug);
};
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------